unit paramParser;

interface

uses sysutils;

 function verifyParam(s : string) : boolean;

 function getParam(s : string; n : integer; var param : single) : boolean;

 procedure showParserLog;

var
  ParserLog : string;

implementation

function verifyParam(s : string) : boolean;
var i, DotCount : integer;
    CommaAllowed, MinusAllowed, SpaceAllowed, DotAllowed : boolean;
begin

//I know that this parser-code isn't nice - but it works and it works well.
  result := true;
  CommaAllowed := false;
  MinusAllowed := true;
  SpaceAllowed := false;
  DotAllowed := false;
  DotCount := 0;

  //No Parameters at all?
  if length(s) = 0 then begin
    parserLog:=parserLog+'-> No paramters given!'+#13;
    result := false;
    exit;
  end;

  //Invalid Characters?
  for i := 1 to length(s) do if not ((integer(s[i])>=48)and(integer(s[i])<=57)or
  (s[i]=',') or (s[i]='.') or (s[i]=' ') or (s[i]='-')) then
  begin
   parserLog:=parserLog+'-> The parameter contains the illegal character "'+s[i]+'"!'+#13;
   result := false;
  end;
  if result = false then exit; //that way the for loop is finished and all errors are recorded

  //Invalid Sequence?
  for i := 1 to length(s) do begin

   if s[i]=',' then if not CommaAllowed then begin
     parserLog:=parserLog+'Illegal sequence of characters in the parameter! At Position '+inttostr(i)+' no "," is allowed!'+#13;
     result := false;
   end else begin
     CommaAllowed := false;
     MinusAllowed := true;
     SpaceAllowed := true;
     DotAllowed := false;
     DotCount := 0;
   end;

   if s[i]='-' then if not MinusAllowed then begin
     parserLog:=parserLog+'Illegal sequence of characters in the parameter! At Position '+inttostr(i)+' no "-" is allowed!'+#13;
     result := false;
   end else begin
     CommaAllowed := false;
     MinusAllowed := false;
     SpaceAllowed := false;
     DotAllowed := false;
   end;

   if s[i]=' ' then if not SpaceAllowed then begin
     parserLog:=parserLog+'Illegal sequence of characters in the parameter! At Position '+inttostr(i)+' no " " is allowed!'+#13;
     result := false;
   end else begin
     CommaAllowed := false;
     MinusAllowed := true;
     SpaceAllowed := true;
     DotAllowed := false;
   end;

   if s[i]='.' then if not (DotAllowed) or (DotCount>=1) then begin
     parserLog:=parserLog+'Illegal sequence of characters in the parameter! At Position '+inttostr(i)+' no "." is allowed!'+#13;
     result := false;
   end else begin
     CommaAllowed := false;
     MinusAllowed := false;
     SpaceAllowed := false;
     DotAllowed := false;
     inc(DotCount);
   end;

   if (integer(s[i])>=48)and(integer(s[i])<=57) then begin
     CommaAllowed := true;
     MinusAllowed := false;
     SpaceAllowed := false;
     DotAllowed := true;
   end;

  end;
end;

function getParam(s : string; n : integer; var param : single) : boolean;
var i,spos, count : integer;

begin

  i := 0;
  spos := 1;
  result := true;
  parserLog := 'The following Errors occurd:'+#13;

  if verifyParam(s) = false then begin
    result := false;
    exit;
  end;

  //find the correct startposition of the required parameter
  i := 0;
  while (i < n) do begin
    while (s[spos] <> ',') and (spos <= length(s)) do inc(spos);
    if s[spos] = ',' then begin
      inc(i);
      inc(spos);
    end else begin
      parserLog:=parserLog+'Not enough parameters given!'+#13;
      result := false;
      exit;
    end;
  end;
  while s[spos] = ' ' do inc(spos);
  //find the length of the parameter
  count := 0;
  while (s[spos+count] <> ',') and (s[spos+count] <> ' ') and (spos+count <= length(s)) do inc(count);
  try
    param := strtofloat(copy(s,spos,count));
  except
    parserLog:=parserLog+'The Parser seems to have a bug! Please report this Error and mail me the parameter you used!'+#13;
    result := false;
  end;
end;

procedure showParserLog;
begin

end;

end.
 